##############################################################################
#
#  Palm-FE Palm Pilot Functional Emulator
#  (c) Vladi Belperchinov-Shabanski "Cade" 2000-2001 
#  <cade@biscom.net> <cade@datamax.bg>
#
#  DISTRIBUTED UNDER GPL LICENSE, SEE `COPYING' FILE FOR DETAILS
#
##############################################################################
package p3_conf;
use Exporter;
@ISA    = qw( Exporter );
@EXPORT = qw( $ROOT $CATFILE $THEME $LANG $MODULES $IDLE
              $BGC $FGC $ACC $TC1 $TC2 $HEC
              $USER $SESS $SCR $MODE $MODULE $WWWPATH $CAT
              %SDA %CATS %MODULES @MODULES $SDAFILE @MODULES_FIND );

#############################################################################
#
# STATIC CONFIGURATION (EDIT IF NEEDED)
#
#############################################################################
#
# $ROOT is the only thing that must be changed, the rest are optional
#
$ROOT    = "/home/cade/pro/palm-fe3"; # palm-fe root directory location

#############################################################################
#
# theme name -- actually this is directory name under  $ROOT/themes which
# contains all required images and colors
#
$THEME   = "default";     # theme name


#############################################################################
#
# language to be used -- currently there is no language support
# however since almost all controls (buttons) are images, language support
# can be done with theme
#
$LANG    = "en";          # language (not used, supported via themes below)

#############################################################################
#
# idle time in minutes for session expiration
#
$IDLE    = 15;            

#############################################################################
#
# categories file name, actually there is no reason for changing this one
#
$CATFILE = "categories";  

#############################################################################
#
# where to look for images, usually this should point to web-visible,
# theme directory. if left blank -- palm-fe will use dynamic images
# i.e. will pipe them through itself
#
# usually it is safe to leave it blank, the only reason for static images
# is performance and caching
#
# `static' images:
#$WWWPATH = "/~cade/palm3/themes";
#
# `dynamic (piped)' images:
$WWWPATH = "";

#############################################################################
#
# tell wich modules are available
#
# module definition syntax is:
#
# $MODULES{ Modulename }{ file } = "mod_file";
# $MODULES{ Modulename }{ icon } = "mod_image";
# $MODULES{ Modulename }{ cats } = "Yes";
#
# `Modulename' is the user-visible name of this module
# `mod_file' is filename of this module w/o `.pm' extension
#            all modules are located in $ROOT/pro directory
# `mod_image' is the image file name that is used for icon (w/o extension)
# Last line is used to tell Palm-FE if this module requires categories
# support or not, possible options here are:
# `undef' -- don't need categories
# `"Yes"' or any valid value -- use categories
#
%MODULES = ();

$MODULES{ Address }{ file } = "p3_addr";
$MODULES{ Address }{ icon } = "address";
$MODULES{ Address }{ cats } = "Yes";

$MODULES{ Memo }{ file } = "p3_memo";
$MODULES{ Memo }{ icon } = "memo";
$MODULES{ Memo }{ cats } = "Yes";

$MODULES{ Todo }{ file } = "p3_todo";
$MODULES{ Todo }{ icon } = "todo";
$MODULES{ Todo }{ cats } = "Yes";

$MODULES{ Welcome }{ file } = "p3_welcome";
$MODULES{ Welcome }{ icon } = "welcome";
$MODULES{ Welcome }{ cats } = undef;

$MODULES{ UserInfo }{ file } = "p3_userinfo";
$MODULES{ UserInfo }{ icon } = "userinfo";
$MODULES{ UserInfo }{ cats } = undef;

$MODULES{ Calc }{ file } = "p3_calc";
$MODULES{ Calc }{ icon } = "calc";
$MODULES{ Calc }{ cats } = undef;

$MODULES{ Find }{ file } = "p3_find";
$MODULES{ Find }{ icon } = "find";
$MODULES{ Find }{ cats } = undef;

# $MODULES{ Calendar }{ file } = "p3_cal";
# $MODULES{ Calendar }{ icon } = "cal";
# $MODULES{ Calendar }{ cats } = "Yes";

#############################################################################
#
# this tells the bottom-line menu order
#
@MODULES = qw( Address Memo Todo Calc Find );

#############################################################################
#
# this tells which modules' data can be searched
#
@MODULES_FIND = qw( Address Memo Todo );

#############################################################################
#
# RUN-TIME CONFIGURATION (WILL BE MODIFIED RUN-TIME, DO NOT EDIT BELOW)
#
#############################################################################

#############################################################################
#
# colors
#
$BGC = "#7b8c5a"; # background
$FGC = "#000000"; # foreground
$ACC = "#ffffff"; # active color
$TC1 = "#9bac7a"; # table rows color 1
$TC2 = "#abbc8a"; # table rows color 2
$HEC = "#cbdc9a"; # header color (tables)

$USER = "";       # username 
$SESS = "";       # session id
$SCR  = "";       # current script url (with session)

$MODE = "";       # current (active) mode (module)
$MODULE = "";     # current module file name

%SDA  = ();       # session data
$SDAFILE = "";    # session data file name

$CAT  = "";       # currently selected category
%CATS = ();       # categories

#############################################################################
#
# EOF
#
#############################################################################
1;

