##############################################################################
#
#  Palm-FE Palm Pilot Functional Emulator
#  (c) Vladi Belperchinov-Shabanski "Cade" 2000-2001 
#  <cade@biscom.net> <cade@datamax.bg>
#
#  DISTRIBUTED UNDER GPL LICENSE, SEE `COPYING' FILE FOR DETAILS
#
##############################################################################
package p3_ses;
use Exporter;
$VERSION = 1.00;
@ISA     = qw( Exporter );
@EXPORT  = qw( http_sid http_user load_hash save_hash );

use strict;
use p3_conf;

use CGI;

#############################################################################

my $hph             = "Content-type: text/html\nPragma: no-cache\n\n
                      <body bgcolor=$BGC text=$FGC link=$FGC vlink=$FGC alink=$ACC>
                      <br><br><br><br>
                      <div align=center>
                      <table border=0 cellpadding=20><tr><td bgcolor=$TC2><div align=center>
                      <h2><code>
                      ";
my $hpf             = "</h2></div></td></tr></table></div>";
my $http_login_page = "$hph
                      <form action=$ENV{ SCRIPT_NAME } method=post>
                      Login for [domain]<br><br>
                      <hr noshade size=2>
                      Username: <input name=username><br>
                      Password: <input name=password><br>
                      <br><input type=submit value='   Login   '>
                      </form>
                      $hpf
                      ";
my $http_bad_login_page = "$hph
                      <form action=$ENV{ SCRIPT_NAME } method=post>
                      Login for [domain]<br><br>
                      <hr noshade size=2>
                      <font color=#ff0000>Bad username or password</font><br><br>
                      Username: <input name=username><br>
                      Password: <input name=password><br>
                      <br><input type=submit value='   Login   '>
                      </form>
                      $hpf";
my $http_login_ok   = "$hph
                      Login for [domain] OK<p>
                      <hr noshade size=2>
                      Your last login was at<br>[lasttime]<p>
                      You came from [lastaddr]<p>
                      <a href=[url]>Click here to proceed</a>
                      $hpf";
my $http_error      = "$hph
                      Login for [domain]<p>
                      <hr noshade size=2>
                      Error encountered,<br>possible reasons are:<p>
                      <li>Authorization file not found<p>
                      <li>Session expired<p>
                      <li>Wrong session id<p>
                      <a href='$ENV{ SCRIPT_NAME }'>Login here</a>
                      $hpf";

my $logfile;
my $histfile;

#############################################################################

sub http_sid
{
  my $sid = $ENV{"PATH_INFO"};
  $sid =~ s/\///g if $sid;
  return $sid;
}

sub http_user
{
  my %arg = @_;
  my $domain = $arg{ Domain } || "unknown";
  my $sespath = $arg{ SesPath } || "/tmp";
  my $passwdfile = $arg{ PasswdFile };
  my $idletime = $arg{ IdleTime } || 3600; # 1 hour default
  $logfile = $arg{ logfile } || "/tmp/http_ses.log";

  $http_bad_login_page =~ s/\[domain\]/$domain/g;
  $http_login_page =~ s/\[domain\]/$domain/g;
  $http_login_ok =~ s/\[domain\]/$domain/g;
  $http_error =~ s/\[domain\]/$domain/g;
  $domain =~ s/[^a-z0-9]/_/gi;

  my $sid = http_sid();

  my $username = CGI::param( "username" );
  my $password = CGI::param( "password" );

  if ( ! -r $passwdfile )
    {
    print $http_error;
    exit;
    }

  if ( ! $sid )
    {
    if ( ! $username && ! $password )
      {
      print $http_login_page;
      exit;
      }

    my %pass_data;
    load_hash( $passwdfile, \%pass_data );

    # check password here...
    my $passok = $pass_data{ $username } eq $password;

    if ( $passok )
      {
      # clean concurent user sessions
      while(<$sespath/http_ses_[0-9]*>)
        {
        my $sesfile = $_;
        my %data;
        load_hash( $sesfile, \%data );
        
        if ( $username eq $data{ username } && 
             time() - $data{ atime } > $idletime )
           { unlink $sesfile; }
        }
      
      do
        {
        $sid = rand() . rand();
        $sid =~ s/0\.//g;
        }
      until ! -e "$sespath/http_ses_$sid";
      my %data;
      $data{ username } = $username;
      $data{ logintime } = time();
      $data{ atime } = time();
      $data{ domain } = $domain;
      save_hash( "$sespath/http_ses_$sid", \%data );
      http_logger( "login ok, $username, $domain" );
      # FIXME: Location https???
      print "Location: http://$ENV{SERVER_NAME}$ENV{ SCRIPT_NAME }/$sid\n\n";
      exit;
      }
    else
      {
      print $http_bad_login_page;
      http_logger( "bad login, $username, $domain" );
      exit;
      }
    }
  else
    {
    my $sidfile = "$sespath/http_ses_$sid";
    if ( ! -r $sidfile )
      {
      print $http_error;
      http_logger( "non-existent session requested" );
      exit;
      }
    else
      {
      my %data;
      my $userok;
      load_hash( "$sespath/http_ses_$sid", \%data );
      if ( time() - $data{ atime } > $idletime )
        {
        unlink $sidfile;
        print $http_error;
        http_logger( "session expired, $data{ username }, $domain" );
        exit;
        }
      if ( $username eq "logout" )
        {
        unlink $sidfile;
        print $http_login_page;
        http_logger( "logout, $data{ username }, $domain" );
        exit;
        }
      if ( $data{ username } eq "" )
        {
        unlink $sidfile;
        print $http_error;
        http_logger( "bad session data, user unknown" );
        exit;
        }
      $data{ atime } = time();
      $userok = $data{ username };
      save_hash( "$sespath/http_ses_$sid", \%data );
      return $userok;
      }
    }
  print $http_error;
  http_logger( "unknown error" );
  exit;
}

#############################################################################

sub save_hash($\%)
{
  my $name = shift;
  my $data = shift;
  open( o, ">" . $name );
  for( keys %$data )
    {
    my $k = $_;
    my $d = $$data{ $k };
    $d =~ s/\n/\\n/g;
    print o "$k=$d\n"; 
    }
  close( o );
  chmod 0600, $name;
}

sub load_hash($\%)
{
  my $name = shift;
  my $data = shift;
  open( i, $name );
  while(<i>)
    {
    chop;
    $$data{ $1 } = $2 if ( /^([^=]+)=(.+)$/ );
    $$data{ $1 } =~ s/\\n/\n/g;
    }
  close( i );
}

sub http_logger($)
{
  my $msg = shift;
  my $now = localtime();
  chomp( $msg );
  $msg = "$now [$ENV{REMOTE_ADDR}] $msg\n";
  open( l, ">>$logfile" );
  print l $msg;
  close( l );
}

#############################################################################

1;
